Index: /trunk/src/sys/arch/mips/sibyte/dev/sbjcn.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbjcn.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbjcn.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbjcn.c,v 1.21.14.1 2009/11/23 18:28:46 matt Exp $ */
+/* $NetBSD: sbjcn.c,v 1.21.14.2 2010/06/09 14:22:16 matt Exp $ */
 
 /*
@@ -104,5 +104,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbjcn.c,v 1.21.14.1 2009/11/23 18:28:46 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbjcn.c,v 1.21.14.2 2010/06/09 14:22:16 matt Exp $");
 
 #define	SBJCN_DEBUG
@@ -220,8 +220,8 @@
 #endif /* KGDB */
 
-static int	sbjcn_match(struct device *, struct cfdata *, void *);
-static void	sbjcn_attach(struct device *, struct device *, void *);
-
-CFATTACH_DECL(sbjcn, sizeof(struct sbjcn_softc),
+static int	sbjcn_match(device_t, cfdata_t, void *);
+static void	sbjcn_attach(device_t, device_t, void *);
+
+CFATTACH_DECL_NEW(sbjcn, sizeof(struct sbjcn_softc),
     sbjcn_match, sbjcn_attach, NULL, NULL);
 
@@ -238,5 +238,5 @@
 
 static int
-sbjcn_match(struct device *parent, struct cfdata *match, void *aux)
+sbjcn_match(device_t parent, cfdata_t match, void *aux)
 {
 	struct sbscd_attach_args *sap = aux;
@@ -249,12 +249,13 @@
 
 static void
-sbjcn_attach(struct device *parent, struct device *self, void *aux)
-{
-	struct sbjcn_softc *sc = (struct sbjcn_softc *)self;
+sbjcn_attach(device_t parent, device_t self, void *aux)
+{
+	struct sbjcn_softc *sc = device_private(self);
 	struct sbscd_attach_args *sap = aux;
 
+	sc->sc_dev = self;
 	sc->sc_addr = sap->sa_base + sap->sa_locs.sa_offset;
 
-	printf("\n");
+	aprint_normal("\n");
 	sbjcn_attach_channel(sc, 0, sap->sa_locs.sa_intr[0]);
 }
@@ -314,6 +315,7 @@
 	ch->ch_rbuf = malloc(sbjcn_rbuf_size << 1, M_DEVBUF, M_NOWAIT);
 	if (ch->ch_rbuf == NULL) {
-		printf("%s: channel %d: unable to allocate ring buffer\n",
-		    sc->sc_dev.dv_xname, chan);
+		aprint_error_dev(sc->sc_dev,
+		    "channel %d: unable to allocate ring buffer\n",
+		    chan);
 		return;
 	}
@@ -329,7 +331,7 @@
 
 		cn_tab->cn_dev = makedev(maj,
-		    (device_unit(&sc->sc_dev) << 1) + chan);
-
-		printf("%s: channel %d: console\n", sc->sc_dev.dv_xname, chan);
+		    (device_unit(sc->sc_dev) << 1) + chan);
+
+		aprint_normal_dev(sc->sc_dev, "channel %d: console\n", chan);
 	}
 
@@ -344,5 +346,5 @@
 
 		SET(ch->ch_hwflags, SBJCN_HW_KGDB);
-		printf("%s: channel %d: kgdb\n", sc->sc_dev.dv_xname, chan);
+		aprint_normal_dev(sc->sc_dev, "channel %d: kgdb\n", chan);
 	}
 #endif
@@ -392,6 +394,7 @@
 	struct tty *tp = ch->ch_tty;
 
-	printf("%s: chan %d: %s %sclocal  %sdcd %sts_carr_on %sdtr %stx_stopped\n",
-	    sc->sc_dev.dv_xname, ch->ch_num, str,
+	aprint_normal_dev(sc->sc_dev,
+	    "chan %d: %s %sclocal  %sdcd %sts_carr_on %sdtr %stx_stopped\n",
+	    ch->ch_num, str,
 	    ISSET(tp->t_cflag, CLOCAL) ? "+" : "-",
 	    ISSET(ch->ch_iports, ch->ch_i_dcd) ? "+" : "-",
@@ -400,6 +403,7 @@
 	    ch->ch_tx_stopped ? "+" : "-");
 
-	printf("%s: chan %d: %s %scrtscts %scts %sts_ttstop  %srts %xrx_flags\n",
-	    sc->sc_dev.dv_xname, ch->ch_num, str,
+	aprint_normal_dev(sc->sc_dev,
+	    "chan %d: %s %scrtscts %scts %sts_ttstop  %srts %xrx_flags\n",
+	    ch->ch_num, str,
 	    ISSET(tp->t_cflag, CRTSCTS) ? "+" : "-",
 	    ISSET(ch->ch_iports, ch->ch_i_cts) ? "+" : "-",
@@ -1047,6 +1051,6 @@
 #ifdef DIAGNOSTIC
 	if (!timo)
-		printf("%s: sbjcn_iflush timeout %02x\n",
-		    ch->ch_sc->sc_dev.dv_xname, reg);
+		aprint_error_dev(ch->ch_sc->sc_dev,
+		    "%s: sbjcn_iflush timeout %02x\n", reg);
 #endif
 }
@@ -1201,5 +1205,5 @@
 
 	log(LOG_WARNING, "%s: channel %d: %d fifo overflow%s, %d ibuf flood%s\n",
-	    sc->sc_dev.dv_xname, ch->ch_num,
+	    device_xname(sc->sc_dev), ch->ch_num,
 	    overflows, overflows == 1 ? "" : "s",
 	    floods, floods == 1 ? "" : "s");
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbjcnvar.h
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbjcnvar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbjcnvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbjcnvar.h,v 1.2 2003/02/07 17:38:49 cgd Exp $ */
+/* $NetBSD: sbjcnvar.h,v 1.2.126.1 2010/06/09 14:22:16 matt Exp $ */
 
 /*
@@ -164,5 +164,5 @@
 
 struct sbjcn_softc {
-	struct device	sc_dev;		/* base device */
+	device_t	sc_dev;		/* base device */
 
 	/* shared data structures */
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbobio.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbobio.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbobio.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbobio.c,v 1.16.98.1 2009/11/23 18:28:47 matt Exp $ */
+/* $NetBSD: sbobio.c,v 1.16.98.2 2010/06/09 14:22:16 matt Exp $ */
 
 /*
@@ -34,5 +34,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbobio.c,v 1.16.98.1 2009/11/23 18:28:47 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbobio.c,v 1.16.98.2 2010/06/09 14:22:16 matt Exp $");
 
 #include <sys/param.h>
@@ -48,8 +48,8 @@
 #include "locators.h"
 
-static int	sbobio_match(struct device *, struct cfdata *, void *);
-static void	sbobio_attach(struct device *, struct device *, void *);
-
-CFATTACH_DECL(sbobio, sizeof(struct device),
+static int	sbobio_match(device_t, cfdata_t, void *);
+static void	sbobio_attach(device_t, device_t, void *);
+
+CFATTACH_DECL_NEW(sbobio, 0,
     sbobio_match, sbobio_attach, NULL, NULL);
 
@@ -105,5 +105,5 @@
 
 static int
-sbobio_match(struct device *parent, struct cfdata *match, void *aux)
+sbobio_match(device_t parent, cfdata_t match, void *aux)
 {
 	struct zbbus_attach_args *zap = aux;
@@ -129,5 +129,5 @@
 
 static void
-sbobio_attach(struct device *parent, struct device *self, void *aux)
+sbobio_attach(device_t parent, device_t self, void *aux)
 {
 	struct sbobio_attach_args sa;
@@ -164,5 +164,5 @@
 	}
 
-	printf(": %s peripherals\n", dscr);
+	aprint_normal(": %s peripherals\n", dscr);
 
 	for (i = 0; i < devcount; i++) {
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbscd.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbscd.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbscd.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbscd.c,v 1.14 2008/06/16 08:36:51 cegger Exp $ */
+/* $NetBSD: sbscd.c,v 1.14.14.1 2010/06/09 14:22:17 matt Exp $ */
 
 /*
@@ -34,5 +34,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbscd.c,v 1.14 2008/06/16 08:36:51 cegger Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbscd.c,v 1.14.14.1 2010/06/09 14:22:17 matt Exp $");
 
 #include <sys/param.h>
@@ -45,8 +45,8 @@
 #include "locators.h"
 
-static int	sbscd_match(struct device *, struct cfdata *, void *);
-static void	sbscd_attach(struct device *, struct device *, void *);
+static int	sbscd_match(device_t, cfdata_t, void *);
+static void	sbscd_attach(device_t, device_t, void *);
 
-CFATTACH_DECL(sbscd, sizeof(struct device),
+CFATTACH_DECL_NEW(sbscd, 0,
     sbscd_match, sbscd_attach, NULL, NULL);
 
@@ -70,5 +70,5 @@
 
 static int
-sbscd_match(struct device *parent, struct cfdata *match, void *aux)
+sbscd_match(device_t parent, cfdata_t match, void *aux)
 {
 	struct zbbus_attach_args *zap = aux;
@@ -81,5 +81,5 @@
 
 static void
-sbscd_attach(struct device *parent, struct device *self, void *aux)
+sbscd_attach(device_t parent, device_t self, void *aux)
 {
 	struct sbscd_attach_args sa;
@@ -87,5 +87,5 @@
 	int locs[SBSCDCF_NLOCS];
 
-	printf("\n");
+	aprint_normal("\n");
 
 	for (i = 0; i < sb1250_sbscd_dev_count; i++) {
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbscn.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbscn.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbscn.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbscn.c,v 1.27.14.2 2009/11/23 18:46:50 matt Exp $ */
+/* $NetBSD: sbscn.c,v 1.27.14.3 2010/06/09 14:22:17 matt Exp $ */
 
 /*
@@ -110,5 +110,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbscn.c,v 1.27.14.2 2009/11/23 18:46:50 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbscn.c,v 1.27.14.3 2010/06/09 14:22:17 matt Exp $");
 
 #define	SBSCN_DEBUG
@@ -230,8 +230,8 @@
 #endif /* KGDB */
 
-static int	sbscn_match(struct device *, struct cfdata *, void *);
-static void	sbscn_attach(struct device *, struct device *, void *);
-
-CFATTACH_DECL(sbscn, sizeof(struct sbscn_softc),
+static int	sbscn_match(device_t, cfdata_t, void *);
+static void	sbscn_attach(device_t, device_t, void *);
+
+CFATTACH_DECL_NEW(sbscn, sizeof(struct sbscn_softc),
     sbscn_match, sbscn_attach, NULL, NULL);
 
@@ -260,5 +260,5 @@
 
 static int
-sbscn_match(struct device *parent, struct cfdata *match, void *aux)
+sbscn_match(device_t parent, cfdata_t match, void *aux)
 {
 	struct sbobio_attach_args *sap = aux;
@@ -271,13 +271,14 @@
 
 static void
-sbscn_attach(struct device *parent, struct device *self, void *aux)
-{
-	struct sbscn_softc *sc = (struct sbscn_softc *)self;
+sbscn_attach(device_t parent, device_t self, void *aux)
+{
+	struct sbscn_softc *sc = device_private(self);
 	struct sbobio_attach_args *sap = aux;
 	int i;
 
+	sc->sc_dev = self;
 	sc->sc_addr = sap->sa_base + sap->sa_locs.sa_offset;
 
-	printf("\n");
+	aprint_normal("\n");
 	for (i = 0; i < 2; i++)
 		sbscn_attach_channel(sc, i, sap->sa_locs.sa_intr[i]);
@@ -345,6 +346,7 @@
 	ch->ch_rbuf = malloc(sbscn_rbuf_size << 1, M_DEVBUF, M_NOWAIT);
 	if (ch->ch_rbuf == NULL) {
-		printf("%s: channel %d: unable to allocate ring buffer\n",
-		    sc->sc_dev.dv_xname, chan);
+		aprint_error_dev(sc->sc_dev,
+		    "channel %d: unable to allocate ring buffer\n",
+		    chan);
 		return;
 	}
@@ -360,7 +362,7 @@
 
 		cn_tab->cn_dev = makedev(maj,
-		    (device_unit(&sc->sc_dev) << 1) + chan);
-
-		printf("%s: channel %d: console\n", sc->sc_dev.dv_xname, chan);
+		    (device_unit(sc->sc_dev) << 1) + chan);
+
+		aprint_normal_dev(sc->sc_dev, "channel %d: console\n", chan);
 	}
 
@@ -375,5 +377,5 @@
 
 		SET(sc->sc_hwflags, SBSCN_HW_KGDB);
-		printf("%s: channel %d: kgdb\n", sc->sc_dev.dv_xname, chan);
+		aprint_normal_dev(sc->sc_dev, "channel %d: kgdb\n", chan);
 	}
 #endif
@@ -382,5 +384,5 @@
 
 #if NRND > 0 && defined(RND_SBSCN)
-	rnd_attach_source(&ch->ch_rnd_source, sc->sc_dev.dv_xname,
+	rnd_attach_source(&ch->ch_rnd_source, device_xname(sc->sc_dev),
 			  RND_TYPE_TTY, 0);
 #endif
@@ -428,6 +430,7 @@
 	struct tty *tp = ch->ch_tty;
 
-	printf("%s: chan %d: %s %sclocal  %sdcd %sts_carr_on %sdtr %stx_stopped\n",
-	    sc->sc_dev.dv_xname, ch->ch_num, str,
+	aprint_normal_dev(sc->sc_dev, 
+	    "chan %d: %s %sclocal  %sdcd %sts_carr_on %sdtr %stx_stopped\n",
+	    ch->ch_num, str,
 	    ISSET(tp->t_cflag, CLOCAL) ? "+" : "-",
 	    ISSET(ch->ch_iports, ch->ch_i_dcd) ? "+" : "-",
@@ -436,6 +439,7 @@
 	    ch->ch_tx_stopped ? "+" : "-");
 
-	printf("%s: chan %d: %s %scrtscts %scts %sts_ttstop  %srts %xrx_flags\n",
-	    sc->sc_dev.dv_xname, ch->ch_num, str,
+	aprint_normal_dev(sc->sc_dev, 
+	    "chan %d: %s %scrtscts %scts %sts_ttstop  %srts %xrx_flags\n",
+	    ch->ch_num, str,
 	    ISSET(tp->t_cflag, CRTSCTS) ? "+" : "-",
 	    ISSET(ch->ch_iports, ch->ch_i_cts) ? "+" : "-",
@@ -1140,6 +1144,7 @@
 #ifdef DIAGNOSTIC
 	if (!timo)
-		printf("%s: sbscn_iflush timeout %02x\n",
-		    ch->ch_sc->sc_dev.dv_xname, reg & 0xff);
+		aprint_error_dev(ch->ch_sc->sc_dev,
+		    "sbscn_iflush timeout %02x\n",
+		    reg & 0xff);
 #endif
 }
@@ -1306,5 +1311,5 @@
 
 	log(LOG_WARNING, "%s: channel %d: %d fifo overflow%s, %d ibuf flood%s\n",
-	    sc->sc_dev.dv_xname, ch->ch_num,
+	    device_xname(sc->sc_dev), ch->ch_num,
 	    overflows, overflows == 1 ? "" : "s",
 	    floods, floods == 1 ? "" : "s");
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbscnvar.h
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbscnvar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbscnvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbscnvar.h,v 1.3 2006/03/07 14:01:41 he Exp $ */
+/* $NetBSD: sbscnvar.h,v 1.3.88.1 2010/06/09 14:22:17 matt Exp $ */
 
 /*
@@ -163,5 +163,5 @@
 
 struct sbscn_softc {
-	struct device	sc_dev;		/* base device */
+	device_t	sc_dev;		/* base device */
 
 	/* shared data structures */
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbsmbus.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbsmbus.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbsmbus.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbsmbus.c,v 1.13 2006/03/28 17:38:25 thorpej Exp $ */
+/* $NetBSD: sbsmbus.c,v 1.13.84.1 2010/06/09 14:22:17 matt Exp $ */
 
 /*
@@ -37,5 +37,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbsmbus.c,v 1.13 2006/03/28 17:38:25 thorpej Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbsmbus.c,v 1.13.84.1 2010/06/09 14:22:17 matt Exp $");
 
 #include <sys/param.h>
@@ -51,9 +51,9 @@
 #include "locators.h"
 
-static int smbus_match(struct device *, struct cfdata *, void *);
-static void smbus_attach(struct device *, struct device *, void *);
+static int smbus_match(device_t, cfdata_t, void *);
+static void smbus_attach(device_t, device_t, void *);
 static int smbus_print(void *, const char *);
 
-CFATTACH_DECL(smbus, sizeof(struct device),
+CFATTACH_DECL_NEW(smbus, 0,
     smbus_match, smbus_attach, NULL, NULL);
 
@@ -74,5 +74,5 @@
 
 static int
-smbus_match(struct device *parent, struct cfdata *match, void *aux)
+smbus_match(device_t parent, cfdata_t match, void *aux)
 {
 
@@ -82,5 +82,5 @@
 
 static void
-smbus_attach(struct device *parent, struct device *self, void *aux)
+smbus_attach(device_t parent, device_t self, void *aux)
 {
 	struct smbus_attach_args sa;
@@ -89,5 +89,5 @@
 
 	found++;
-	printf("\n");
+	aprint_normal("\n");
 
 	for (i = 0; i < smbus_dev_count; i++) {
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbtimer.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbtimer.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbtimer.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbtimer.c,v 1.13.28.2 2009/11/23 18:46:50 matt Exp $ */
+/* $NetBSD: sbtimer.c,v 1.13.28.3 2010/06/09 14:22:17 matt Exp $ */
 
 /*
@@ -34,5 +34,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbtimer.c,v 1.13.28.2 2009/11/23 18:46:50 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbtimer.c,v 1.13.28.3 2010/06/09 14:22:17 matt Exp $");
 
 #include <sys/param.h>
@@ -48,5 +48,5 @@
 
 struct sbtimer_softc {
-	struct device sc_dev;
+	device_t sc_dev;
 	void	*sc_intrhand;
 	int	sc_flags;
@@ -59,8 +59,8 @@
 #define	WRITE_REG(rp, val)	(mips3_sd((volatile uint64_t *)(rp), (val)))
 
-static int	sbtimer_match(struct device *, struct cfdata *, void *);
-static void	sbtimer_attach(struct device *, struct device *, void *);
-
-CFATTACH_DECL(sbtimer, sizeof(struct sbtimer_softc),
+static int	sbtimer_match(device_t, cfdata_t, void *);
+static void	sbtimer_attach(device_t, device_t, void *);
+
+CFATTACH_DECL_NEW(sbtimer, sizeof(struct sbtimer_softc),
     sbtimer_match, sbtimer_attach, NULL, NULL);
 
@@ -72,5 +72,5 @@
 
 static int
-sbtimer_match(struct device *parent, struct cfdata *match, void *aux)
+sbtimer_match(device_t parent, cfdata_t match, void *aux)
 {
 	struct sbscd_attach_args *sap = aux;
@@ -83,13 +83,14 @@
 
 static void
-sbtimer_attach(struct device *parent, struct device *self, void *aux)
+sbtimer_attach(device_t parent, device_t self, void *aux)
 {
 	struct sbscd_attach_args *sa = aux;
-	struct sbtimer_softc *sc = (struct sbtimer_softc *)self;
+	struct sbtimer_softc *sc = device_private(self);
 	void (*fun)(void *, uint32_t, vaddr_t);
 	int ipl;
 	const char *comment = "";
 
-	sc->sc_flags = device_cfdata(&sc->sc_dev)->cf_flags;
+	sc->sc_dev = self;
+	sc->sc_flags = device_cfdata(sc->sc_dev)->cf_flags;
 	sc->sc_addr_icnt = (uint64_t *)MIPS_PHYS_TO_KSEG1(sa->sa_base +
 	    sa->sa_locs.sa_offset + R_SCD_TIMER_INIT);
@@ -99,5 +100,5 @@
 	    sa->sa_locs.sa_offset + R_SCD_TIMER_CFG);
 
-	printf(": ");
+	aprint_normal(": ");
 	if ((sc->sc_flags & SBTIMER_CLOCK) != 0) {
 		ipl = IPL_CLOCK;
@@ -110,5 +111,5 @@
 			goto not_really;
 		}
-		printf("system timer");
+		aprint_normal("system timer");
 	} else if ((sc->sc_flags & SBTIMER_STATCLOCK) != 0) {
 		ipl = IPL_HIGH;
@@ -122,12 +123,12 @@
 			goto not_really;
 		}
-		printf("system statistics timer");
+		aprint_normal("system statistics timer");
 	} else {
 not_really:
 		ipl = IPL_BIO;			/* XXX -- pretty low */
 		fun = sbtimer_miscintr;
-		printf("general-purpose timer%s", comment);
+		aprint_normal("general-purpose timer%s", comment);
 	}
-	printf("\n");
+	aprint_normal("\n");
 
 	/* clear intr & disable timer. */
@@ -143,9 +144,9 @@
 	struct sbtimer_softc *sc = arg;
 
-	printf("%s: ", sc->sc_dev.dv_xname);
 	if ((1000000 % hz) == 0)
-		printf("%dHz system timer\n", hz);
+		aprint_normal_dev(sc->sc_dev, "%dHz system timer\n", hz);
 	else {
-		printf("cannot get %dHz clock; using 1000Hz\n", hz);
+		aprint_error_dev(sc->sc_dev, 
+		    "cannot get %dHz clock; using 1000Hz\n", hz);
 		hz = 1000;
 		tick = 1000000 / hz;
@@ -154,6 +155,6 @@
 	WRITE_REG(sc->sc_addr_cfg, 0x00);		/* XXX */
 	if (G_SYS_PLL_DIV(READ_REG(MIPS_PHYS_TO_KSEG1(A_SCD_SYSTEM_CFG))) == 0) {
-		printf("%s: PLL_DIV == 0; speeding up clock ticks for simulator\n",
-		    sc->sc_dev.dv_xname);
+		aprint_debug_dev(sc->sc_dev,
+		    "PLL_DIV == 0; speeding up clock ticks for simulator\n");
 		WRITE_REG(sc->sc_addr_icnt, (tick/100) - 1); /* XXX */
 	} else {
Index: /trunk/src/sys/arch/mips/sibyte/dev/sbwdog.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/dev/sbwdog.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/dev/sbwdog.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbwdog.c,v 1.7.94.2 2010/05/15 06:22:38 matt Exp $ */
+/* $NetBSD: sbwdog.c,v 1.7.94.3 2010/06/09 14:22:17 matt Exp $ */
 
 /*
@@ -41,5 +41,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sbwdog.c,v 1.7.94.2 2010/05/15 06:22:38 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sbwdog.c,v 1.7.94.3 2010/06/09 14:22:17 matt Exp $");
 
 #include "locators.h"
@@ -67,6 +67,6 @@
 };
 
-static int sbwdog_match(struct device *, struct cfdata *, void *);
-static void sbwdog_attach(struct device *, struct device *, void *);
+static int sbwdog_match(device_t, cfdata_t, void *);
+static void sbwdog_attach(device_t, device_t, void *);
 static int sbwdog_tickle(struct sysmon_wdog *);
 static int sbwdog_setmode(struct sysmon_wdog *);
@@ -80,5 +80,5 @@
 
 static int
-sbwdog_match(struct device *parent, struct cfdata *cf, void *aux)
+sbwdog_match(device_t parent, cfdata_t cf, void *aux)
 {
 	struct sbscd_attach_args *sa = aux;
@@ -91,5 +91,5 @@
 
 static void
-sbwdog_attach(struct device *parent, struct device *self, void *aux)
+sbwdog_attach(device_t parent, device_t self, void *aux)
 {
 	struct sbwdog_softc *sc = device_private(self);
Index: /trunk/src/sys/arch/mips/sibyte/pci/sbbrz.c
===================================================================
--- /trunk/src/sys/arch/mips/sibyte/pci/sbbrz.c	(revision 151)
+++ /trunk/src/sys/arch/mips/sibyte/pci/sbbrz.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: sbbrz.c,v 1.1.2.5 2010/02/23 20:33:48 matt Exp $ */
+/* $NetBSD: sbbrz.c,v 1.1.2.6 2010/06/09 14:22:17 matt Exp $ */
 
 /*
@@ -213,9 +213,9 @@
 	if (pnp)
 #if _has_pba_busname
-		printf("%s at %s\n", pba->pba_busname, pnp);
+		aprint_normal("%s at %s\n", pba->pba_busname, pnp);
 #else
-		printf("\n* sbbrz_pci at %s", pnp);
+		aprint_normal("\n* sbbrz_pci at %s", pnp);
 #endif
-	printf(" bus %d", pba->pba_bus);
+	aprint_normal(" bus %d", pba->pba_bus);
 	return (UNCONF);
 }       
Index: /trunk/src/sys/arch/mipsco/include/intr.h
===================================================================
--- /trunk/src/sys/arch/mipsco/include/intr.h	(revision 151)
+++ /trunk/src/sys/arch/mipsco/include/intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: intr.h,v 1.16.36.1 2010/02/05 07:39:54 matt Exp $	*/
+/*	$NetBSD: intr.h,v 1.16.36.2 2010/12/29 08:16:21 matt Exp $	*/
 
 /*
@@ -34,27 +34,10 @@
 #define _MACHINE_INTR_H_
 
-#define	IPL_NONE	0	/* disable only this interrupt */
-#define	IPL_SOFTCLOCK	1	/* generic software interrupts */
-#define	IPL_SOFTBIO	1	/* clock software interrupts */
-#define	IPL_SOFTNET	2	/* network software interrupts */
-#define	IPL_SOFTSERIAL	2	/* serial software interrupts */
-#define	IPL_VM		3
-#define	IPL_SCHED	4
-#define	IPL_HIGH	4	/* disable all interrupts */
-
-#define	IPL_N		5
-
-/* Interrupt sharing types. */
-#define IST_NONE	0	/* none */
-#define IST_PULSE	1	/* pulsed */
-#define IST_EDGE	2	/* edge-triggered */
-#define IST_LEVEL	3	/* level-triggered */
+#include <mips/intr.h>
 
 #ifdef _KERNEL
-#ifndef _LOCORE
-#include <sys/types.h>
-#include <sys/device.h>
-#include <sys/queue.h>
-#include <mips/locore.h>
+#ifdef __INTR_PRIVATE
+#include <sys/evcnt.h>
+#include <mips/cpuregs.h>
 
 /*
@@ -70,33 +53,7 @@
 #define MIPS_INT_MASK_SPL5	(MIPS_INT_MASK_5|MIPS_INT_MASK_SPL4)
 
-#define spl0()		(void)_spllower(0)
-#define splx(s)		(void)_splset(s)
-#define splvm()		_splraise(MIPS_INT_MASK_SPL2)
-#define splsched()	_splraise(MIPS_INT_MASK_SPL2)
-#define splhigh()	_splraise(MIPS_INT_MASK_SPL2)
-
-#define splsoftclock()	_splraise(MIPS_INT_MASK_SPL_SOFT0)
-#define splsoftbio()	_splraise(MIPS_INT_MASK_SPL_SOFT0)
-#define	splsoftnet()	_splraise(MIPS_INT_MASK_SPL_SOFT1)
-#define	splsoftserial()	_splraise(MIPS_INT_MASK_SPL_SOFT1)
-
-typedef int ipl_t;
-typedef struct {
-	int _sr;
-} ipl_cookie_t;
-
-ipl_cookie_t makeiplcookie(ipl_t ipl);
-
-static inline int
-splraiseipl(ipl_cookie_t icookie)
-{
-
-	return _splraise(icookie._sr);
-}
-
 struct mipsco_intrhand {
-	LIST_ENTRY(mipsco_intrhand)
-		ih_q;
-	int	(*ih_fun) __P((void *));
+	LIST_ENTRY(mipsco_intrhand) ih_q;
+	int	(*ih_fun)(void *);
 	void	 *ih_arg;
 	struct	mipsco_intr *ih_intrhead;
@@ -105,12 +62,16 @@
 
 struct mipsco_intr {
-	LIST_HEAD(,mipsco_intrhand)
-		intr_q;
+	LIST_HEAD(,mipsco_intrhand) intr_q;
 	struct	evcnt ih_evcnt;
 	unsigned long intr_siq;
 };
 
+extern const struct ipl_sr_map mipsco_ipl_sr_map;
+extern struct mipsco_intrhand intrtab[];
+#define	CALL_INTR(lev)	((*intrtab[lev].ih_fun)(intrtab[lev].ih_arg))
 
-extern struct mipsco_intrhand intrtab[];
+#define MAX_INTR_COOKIES 16
+
+#endif /* __INTR_PRIVATE */
 
 #define SYS_INTR_LEVEL0	0
@@ -127,9 +88,4 @@
 #define SYS_INTR_ATBUS	11
 
-#define MAX_INTR_COOKIES 16
-
-#define	CALL_INTR(lev)	((*intrtab[lev].ih_fun)(intrtab[lev].ih_arg))
-
-#endif /* !_LOCORE */
 #endif /* _KERNEL */
 #endif /* _MACHINE_INTR_H_ */
Index: /trunk/src/sys/arch/mipsco/include/sysconf.h
===================================================================
--- /trunk/src/sys/arch/mipsco/include/sysconf.h	(revision 151)
+++ /trunk/src/sys/arch/mipsco/include/sysconf.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sysconf.h,v 1.4 2007/03/04 06:00:13 christos Exp $	*/
+/*	$NetBSD: sysconf.h,v 1.4.62.1 2010/12/29 08:16:21 matt Exp $	*/
 
 /*
@@ -54,9 +54,9 @@
 	 *	clkinit		-	Initialize clocks
 	 */
-	void	(*cons_init) __P((void));
-	void	(*iointr) __P((unsigned, unsigned, unsigned, unsigned));
-	int	(*memsize) __P((void *));
-	void	(*intr_establish) __P((int, int (*)__P((void *)), void *)); 
-	void	(*clkinit) __P((void));
+	void	(*cons_init)(void);
+	void	(*iointr)(uint32_t, vaddr_t, uint32_t);
+	int	(*memsize)(void *);
+	void	(*intr_establish)(int, int (*)(void *), void *); 
+	void	(*clkinit)(void);
 };
 
Index: /trunk/src/sys/arch/mipsco/mipsco/autoconf.c
===================================================================
--- /trunk/src/sys/arch/mipsco/mipsco/autoconf.c	(revision 151)
+++ /trunk/src/sys/arch/mipsco/mipsco/autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: autoconf.c,v 1.18 2007/12/03 15:33:57 ad Exp $	*/
+/*	$NetBSD: autoconf.c,v 1.18.36.1 2010/12/29 08:16:21 matt Exp $	*/
 
 /*
@@ -85,6 +85,7 @@
  */
 
+#define __INTR_PRIVATE
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.18 2007/12/03 15:33:57 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.18.36.1 2010/12/29 08:16:21 matt Exp $");
 
 #include <sys/param.h>
Index: /trunk/src/sys/arch/mipsco/mipsco/interrupt.c
===================================================================
--- /trunk/src/sys/arch/mipsco/mipsco/interrupt.c	(revision 151)
+++ /trunk/src/sys/arch/mipsco/mipsco/interrupt.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: interrupt.c,v 1.6.18.1 2010/02/05 07:39:54 matt Exp $	*/
+/*	$NetBSD: interrupt.c,v 1.6.18.2 2010/12/29 08:16:21 matt Exp $	*/
 
 /*
@@ -30,11 +30,11 @@
  */
 
+#define __INTR_PRIVATE
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.6.18.1 2010/02/05 07:39:54 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.6.18.2 2010/12/29 08:16:21 matt Exp $");
 
 #include <sys/param.h>
 #include <sys/malloc.h>
 #include <sys/intr.h>
-#include <sys/cpu.h>
 
 #include <uvm/uvm_extern.h>
@@ -43,30 +43,20 @@
 
 void
-cpu_intr(status, cause, pc, ipending)
-	u_int32_t status;
-	u_int32_t cause;
-	u_int32_t pc;
-	u_int32_t ipending;
+cpu_intr(int ppl, vaddr_t pc, uint32_t status)
 {
-	struct cpu_info *ci;
+	uint32_t ipending;
+	int ipl;
 
-	ci = curcpu();
 	uvmexp.intrs++;
 
-	/* device interrupts */
-	ci->ci_idepth++;
-	(*platform.iointr)(status, cause, pc, ipending);
-	ci->ci_idepth--;
+	while (ppl < (ipl = splintr(&ipending))) {
+		/* device interrupts */
+		(*platform.iointr)(status, pc, ipending);
+	}
 
-#ifdef __HAVE_FAST_SOFTINTS
-	/* software simulated interrupt */
-	ipending &= MIPS_SOFT_INT_MASK;
-	if (ipending == 0)
-		return;
-	softint_process(ipending);
-#endif
 }
 
-static const int ipl_sr_bits[] = {
+const struct ipl_sr_map mipsco_ipl_sr_map = {
+    .sr_bits = {
 	[IPL_NONE] = 0,
 	[IPL_SOFTCLOCK] = MIPS_INT_MASK_SPL_SOFT0,
@@ -74,10 +64,5 @@
 	[IPL_VM] = MIPS_INT_MASK_SPL2,
 	[IPL_SCHED] = MIPS_INT_MASK_SPL2,
+	[IPL_HIGH] = MIPS_INT_MASK,
+    },
 };
-
-ipl_cookie_t
-makeiplcookie(ipl_t ipl)
-{
-
-	return (ipl_cookie_t){._sr = ipl_sr_bits[ipl]};
-}
Index: /trunk/src/sys/arch/mipsco/mipsco/machdep.c
===================================================================
--- /trunk/src/sys/arch/mipsco/mipsco/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mipsco/mipsco/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.58.10.3 2010/03/21 17:38:34 cliff Exp $	*/
+/*	$NetBSD: machdep.c,v 1.58.10.4 2010/12/29 08:16:21 matt Exp $	*/
 
 /*
@@ -77,5 +77,5 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.58.10.3 2010/03/21 17:38:34 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.58.10.4 2010/12/29 08:16:21 matt Exp $");
 
 /* from: Utah Hdr: machdep.c 1.63 91/04/24 */
@@ -151,10 +151,10 @@
 int mem_cluster_cnt;
 
-void to_monitor __P((int)) __attribute__((__noreturn__));
-void prom_halt __P((int)) __attribute__((__noreturn__));
+void to_monitor(int) __dead;
+void prom_halt(int) __dead;
 
 #ifdef	KGDB
-void zs_kgdb_init __P((void));
-void kgdb_connect __P((int));
+void zs_kgdb_init(void);
+void kgdb_connect(int);
 #endif
 
@@ -162,13 +162,13 @@
  *  Local functions.
  */
-int initcpu __P((void));
-void configure __P((void));
-
-void mach_init __P((int, char *[], char*[], u_int, char *));
-int  memsize_scan __P((void *));
+int initcpu(void);
+void configure(void);
+
+void mach_init(int, char *[], char*[], u_int, char *);
+int  memsize_scan(void *);
 
 #ifdef DEBUG
 /* stacktrace code violates prototypes to get callee's registers */
-extern void stacktrace __P((void)); /*XXX*/
+extern void stacktrace(void); /*XXX*/
 #endif
 
@@ -183,13 +183,13 @@
 
 /* locore callback-vector setup */
-extern void mips_vector_init  __P((const struct splsw *));
-extern void prom_init  __P((void));
-extern void pizazz_init __P((void));
+extern void mips_vector_init(const struct splsw *);
+extern void prom_init(void);
+extern void pizazz_init(void);
 
 /* platform-specific initialization vector */
-static void	unimpl_cons_init __P((void));
-static void	unimpl_iointr __P((unsigned, unsigned, unsigned, unsigned));
-static int	unimpl_memsize __P((void *));
-static void	unimpl_intr_establish __P((int, int (*)__P((void *)), void *));
+static void	unimpl_cons_init(void);
+static void	unimpl_iointr(uint32_t, vaddr_t, uint32_t);
+static int	unimpl_memsize(void *);
+static void	unimpl_intr_establish(int, int (*)(void *), void *);
 
 struct platform platform = {
@@ -206,9 +206,9 @@
 extern struct consdev consdev_zs;
 
-static void null_cnprobe __P((struct consdev *));
-static void prom_cninit __P((struct consdev *));
-static int  prom_cngetc __P((dev_t));
-static void prom_cnputc __P((dev_t, int));
-static void null_cnpollc __P((dev_t, int));
+static void null_cnprobe(struct consdev *);
+static void prom_cninit(struct consdev *);
+static int  prom_cngetc(dev_t);
+static void prom_cnputc(dev_t, int);
+static void null_cnpollc(dev_t, int);
 
 struct consdev consdev_prom = {
@@ -247,5 +247,4 @@
 #endif
 
-
 	/* Check for valid bootinfo passed from bootstrap */
 	if (bim == BOOTINFO_MAGIC) {
@@ -265,4 +264,11 @@
 	memset(edata, 0, end - edata);
 
+	/*
+	 * Copy exception-dispatch code down to exception vector.
+	 * Initialize locore-function vector.
+	 * Clear out the I and D caches.
+	 */
+	mips_vector_init(NULL);
+
 #if NKSYMS || defined(DDB) || defined(LKM)
 	bi_syms = lookup_bootinfo(BTINFO_SYMTAB);
@@ -298,11 +304,4 @@
 	mem_clusters[0].size  = ctob(physmem);
 	mem_cluster_cnt = 1;
-
-	/*
-	 * Copy exception-dispatch code down to exception vector.
-	 * Initialize locore-function vector.
-	 * Clear out the I and D caches.
-	 */
-	mips_vector_init();
 
 	/* Look at argv[0] and compute bootdev */
@@ -532,5 +531,5 @@
 
 int
-initcpu()
+initcpu(void)
 {
 	spl0();		/* safe to turn interrupts on now */
@@ -539,5 +538,5 @@
 
 static void
-unimpl_cons_init()
+unimpl_cons_init(void)
 {
 
@@ -546,9 +545,5 @@
 
 static void
-unimpl_iointr(mask, pc, statusreg, causereg)
-	u_int mask;
-	u_int pc;
-	u_int statusreg;
-	u_int causereg;
+unimpl_iointr(uint32_t status, vaddr_t pc, uint32_t ipending)
 {
 
@@ -557,6 +552,5 @@
 
 static int
-unimpl_memsize(first)
-void *first;
+unimpl_memsize(void *first)
 {
 
@@ -565,8 +559,5 @@
 
 void
-unimpl_intr_establish(level, func, arg)
-	int level;
-	int (*func) __P((void *));
-	void *arg;
+unimpl_intr_establish(int level, int (*func)(void *), void *arg)
 {
 	panic("sysconf.init didn't init intr_establish");
@@ -574,6 +565,5 @@
 
 void
-delay(n)
-	int n;
+delay(int n)
 {
 	DELAY(n);
